package com.sa.ibiz.demo.demo.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import com.sa.ibiz.demo.demo.domain.XM;
import com.sa.ibiz.demo.demo.service.dto.XMSearchFilter;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
public interface XMMapper extends BaseMapper<XM>{
    @CacheEvict( value="entity",key = "'XM:'+#p0.xmid")
    void updateOne(@Param("xm") XM xm);
    List<XM> searchDefault(@Param("srf") XMSearchFilter searchfilter,@Param("ew") Wrapper<XM> wrapper) ;
    Page<XM> searchDefault(IPage page, @Param("srf") XMSearchFilter searchfilter, @Param("ew") Wrapper<XM> wrapper) ;
    @Select("${sql}")
    List<Map<String,Object>> selectRow( @Param("sql")String sql);
    @Override
    @Cacheable( value="entity",key = "'XM:'+#p0")
    XM selectById(Serializable id);
    @Override
    @CacheEvict( value="entity",key = "'XM:'+#p0.xmid")
    int updateById(@Param(Constants.ENTITY) XM entity);
    @Override
    @CacheEvict( value="entity",key = "'XM:'+#p0.xmid")
    int insert(XM entity);
    @Override
    @CacheEvict( value="entity",key = "'XM:'+#p0")
    int deleteById(Serializable id);
}